/*
** XFA Info - Example Of How To Get Infos About An XFA Anim In AmigaE
**
** Code Written By: Fabio Rotondo
** Based Upon An Original Blitz2 Code By Mik Of ClassX
**
** This code is Public Domain.
**
** Written For ClassX
*/

MODULE 'xfa','libraries/xfa','dos/rdargs'

PROC main()
  DEF args=NIL:PTR TO LONG, rdargs 
  DEF head:PTR TO xfa_head 
  
  WriteF('XFAInfo V0.1 - By Fabio Rotondo.\n')
  
  rdargs:=ReadArgs('NAME/A', args, NIL)
  IF rdargs
    IF (xfabase:=OpenLibrary('xfa.library',0))
      IF (XfA_LoadAnim(args[0],0,0,FALSE) = 0)
        head:=XfA_HeadPtr()
        WriteF('Anim File: \s\n', args[0])
        WriteF('XFA Width  = \d\n', head.bytesperrow*8)
        WriteF('XFA Height = \d\n', head.rows)
        WriteF('XFA Depth  = \d\n', head.depth)   
        WriteF('XFA ModeID = \h\n', head.modeid)
        WriteF('XFA Flags  = \d\n', head.flags)
        WriteF('XFA Frames = \d\n', head.nframes)
      ELSE
        WriteF('File not found or read error.\n')
      ENDIF
      CloseLibrary(xfabase)
    ELSE
      WriteF('Cannot Open xfa.library\n')
    ENDIF
    FreeArgs(rdargs)
  ELSE
    WriteF('Bad Args.\n')
  ENDIF
  CleanUp(0) 
ENDPROC
